#
import Define as DEF
import Command as CMD
import Commandlist as CML
import CommandExecutor as CEX
#
class CCommandViewer(CEX.CCommandExecutor):
    #
    def Execute(self, commandlist):
        Result = True;
        print('CommandViewer[{0}]'.format(len(commandlist)))
        #print(commandlist.Lines())
        for Command in commandlist:
            #- C ------------------------------------------------
            if (DEF.CODE_COMMENT == Command.Code):
                Text = 'Comment[' + Command.Code + ' '
                for P in Command.Parameterlist:
                    Text += P.Value
                Text += ']'
                print(Text)
            #- G ------------------------------------------------
            elif ('G00' == Command.Code) or ('G0' == Command.Code):
                print(Command.BuildCommandLine() + '; Rapid Positioning')
            elif ('G01' == Command.Code) or ('G1' == Command.Code):
                print(Command.BuildCommandLine() + '; Cut Line Moving')
            elif ('G02' == Command.Code) or ('G2' == Command.Code):
                print(Command.BuildCommandLine() + '; Cut Arc Clockwise')
            elif ('G03' == Command.Code) or ('G3' == Command.Code):
                print(Command.BuildCommandLine() + '; Cut Arc Counter-Clockwise')
            elif ('G17' == Command.Code):
                print(Command.BuildCommandLine() + '; Arc in XY-Plane')
            elif ('G18' == Command.Code):
                print(Command.BuildCommandLine() + '; Arc in XZ-Plane')
            elif ('G19' == Command.Code):
                print(Command.BuildCommandLine() + '; Arc in YZ-Plane')
            elif ('G20' == Command.Code):
                print(Command.BuildCommandLine() + '; Unit Inches')
            elif ('G21' == Command.Code):
                print(Command.BuildCommandLine() + '; Unit Millimeters')
            elif ('G40' == Command.Code):
                print(Command.BuildCommandLine() + '; Cutter Compensation Off')
            elif ('G49' == Command.Code):
                print(Command.BuildCommandLine() + '; Cancel Tool Length Offset')
            elif ('G53' == Command.Code):
                print(Command.BuildCommandLine() + '; Use Machine Coordinates')
            elif ('G54' == Command.Code):
                print(Command.BuildCommandLine() + '; Activate Saved Origin')
            elif ('G80' == Command.Code):
                print(Command.BuildCommandLine() + '; Cancel')
            elif ('G90' == Command.Code):
                print(Command.BuildCommandLine() + '; Mode Absolute')
            elif ('G91' == Command.Code):
                print(Command.BuildCommandLine() + '; Mode Absolute')
            #- M ------------------------------------------------
            elif ('M0' == Command.Code):
                print(Command.BuildCommandLine() + '; Pause')
            elif ('M1' == Command.Code):
                print(Command.BuildCommandLine() + '; Pause on StopSwitch')
            elif ('M2' == Command.Code):
                print(Command.BuildCommandLine() + '; Program End')
            elif ('M3' == Command.Code):
                print(Command.BuildCommandLine() + '; Start Spindle Clockwise')
            elif ('M4' == Command.Code):
                print(Command.BuildCommandLine() + '; Start Spindle CounterClockwise')
            elif ('M5' == Command.Code):
                print(Command.BuildCommandLine() + '; Stop Spindle')
            elif ('M6' == Command.Code):
                print(Command.BuildCommandLine() + '; Select Tool')
            elif ('M8' == Command.Code):
                print(Command.BuildCommandLine() + '; Coolant On')
            elif ('M9' == Command.Code):
                print(Command.BuildCommandLine() + '; Coolant Off')
            elif ('M25' == Command.Code):
                print(Command.BuildCommandLine() + '; Pause SDCard Execution')
            elif ('M30' == Command.Code):
                print(Command.BuildCommandLine() + '; Program End')
            elif ('M99' == Command.Code):
                print(Command.BuildCommandLine() + '; Return from SubProgram')
            #- E ------------------------------------------------
            else:
                DEF.Error('Invalid Command [' + Command.Code + ']')
                Result = false
                break
        return Result
